import minako.parser.*;
import minako.lexer.*;
import minako.node.*;

import java.io.*;

public class Minako {
	
	public final static int TYP_VOID  = 0;
	public final static int TYP_INT  = 1;
	public final static int TYP_FLOAT  = 2;
	public final static int TYP_BOOLEAN  = 3;
	public static String className = "Minako";
	public static File inputfile;
	
    public static void main(String[] args) {

          if (args.length < 1) {
               System.out.println("Usage:");
               System.out.println("java Minako <filename>");
          }

          try {
        	  
        	  inputfile = new File(args[0]);
        	  className = inputfile.getName().substring(0, inputfile.getName().length() - 3);
        	  // create lexer
        	  Lexer lexer = new Lexer (new PushbackReader(new BufferedReader(new FileReader(args[0])), 1024));

        	  // parser program
        	  Parser parser = new Parser(lexer);

        	  Start ast = parser.parse();

        	  // check program semantics
        	  ast.apply(new Semantic());

        	  // generate class file
        	  // ast.apply(new ClassGenerator());
          }
          catch (Exception e) {
               System.out.println(e);
          }
     }
     
     public static void error(String errormsg) {
    	 System.out.println(errormsg);
    	 System.exit(-1);
     }
}
